require("util")

data:extend(
{
  { type = "recipe", name = "mini-assembling-machine-1",
    enabled = "false",
    energy_required = 6,
    ingredients =
    {
      {"assembling-machine-1", 1},
--      {"plastic-bar", 3},
      {"steel-plate", 1},
      {"electronic-circuit", 2}
    },
    result = "mini-assembling-machine-1"
  },
  { type = "recipe", name = "mini-assembling-machine-2",
    enabled = "false",
    energy_required = 9,
    ingredients =
    {
      {"assembling-machine-2", 1},
      {"plastic-bar", 3},
      {"steel-plate", 1},
      {"advanced-circuit", 2}
    },
    result = "mini-assembling-machine-2"
  },
  { type = "recipe", name = "mini-assembling-machine-3",
    enabled = "false",
    energy_required = 12,
    ingredients =
    {
      {"assembling-machine-3", 1},
      {"plastic-bar", 3},
      {"steel-plate", 1},
      {"advanced-circuit", 4}
    },
    result = "mini-assembling-machine-3"
  },
  { type = "recipe", name = "mini-electric-furnace",
    enabled = "false",
    energy_required = 10,
    ingredients = {{"steel-furnace", 1}, {"electric-furnace", 10}, {"processing-unit", 2}, {"plastic-bar", 5}},
    result = "mini-electric-furnace"
  },
  
  { type = "item", name = "mini-assembling-machine-1",
    icon = "__Miniaturization__/graphics/icons/mini-assembling-machine.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "a[mini-assembling-machine-1]",
    place_result = "mini-assembling-machine-1",
    stack_size = 50
  },
  { type = "item", name = "mini-assembling-machine-2",
    icon = "__Miniaturization__/graphics/icons/mini-assembling-machine-2.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "b[mini-assembling-machine-2]",
    place_result = "mini-assembling-machine-2",
    stack_size = 50
  },
  { type = "item", name = "mini-assembling-machine-3",
    icon = "__Miniaturization__/graphics/icons/mini-assembling-machine-3.png",
    flags = {"goes-to-quickbar"},
    subgroup = "production-machine",
    order = "c[mini-assembling-machine-3]",
    place_result = "mini-assembling-machine-3",
    stack_size = 50
  },
  { type = "item", name = "mini-electric-furnace",
    icon = "__Miniaturization__/graphics/icons/mini-electric-furnace.png",
    flags = {"goes-to-quickbar"},
    subgroup = "smelting-machine",
    order = "c[mini-electric-furnace]",
    place_result = "mini-electric-furnace",
    stack_size = 50
  },
  })

function adjustanimation(anim,scale)
	if anim == nil then return end
	anim.scale = (anim.scale or 1) * scale
	anim.shift = {anim.shift[1]*scale,anim.shift[2]*scale}
end
  
function MiniCopy(entity, scale)
	local m = util.table.deepcopy(entity)
	m.name = "mini-"..m.name
	if m.minable then m.minable.result = "mini-"..m.minable.result end
	m.collision_box = {{m.collision_box[1][1]*scale,m.collision_box[1][2]*scale},{m.collision_box[2][1]*scale,m.collision_box[2][2]*scale}}
	m.selection_box = {{m.selection_box[1][1]*scale,m.selection_box[1][2]*scale},{m.selection_box[2][1]*scale,m.selection_box[2][2]*scale}}
	
	if m.light then m.light.size = m.light.size * scale end
	if m.working_sound then m.working_sound.apparent_volume = m.working_sound.apparent_volume * scale end
	
	adjustanimation(m.animation,scale)
	if m.working_visualizations then
		for _,piece in pairs(m.working_visualizations) do
			adjustanimation(piece.animation,scale)
		end
	end
	
	return m
--	data:extend{m}
end

local mini

mini = MiniCopy(data.raw["assembling-machine"]["assembling-machine-1"],2/3)
mini.max_health = 180
mini.corpse = "medium-remnants"
mini.crafting_speed = 0.6
mini.energy_source.emissions = 1.8/75
mini.energy_usage = "75kW"
mini.ingredient_count = 1
mini.module_slots = 1

mini.fluid_boxes=nil
data:extend{mini}

mini = MiniCopy(data.raw["assembling-machine"]["assembling-machine-2"],2/3)
mini.max_health = 200
mini.corpse = "medium-remnants"
mini.crafting_speed = 0.8
mini.energy_source.emissions = 1.4/140
mini.energy_usage = "140kW"
mini.ingredient_count = 2
mini.module_slots = 1
mini.fluid_boxes=nil
data:extend{mini}

mini = MiniCopy(data.raw["assembling-machine"]["assembling-machine-3"],2/3)
mini.max_health = 250
mini.corpse = "medium-remnants"
mini.crafting_speed = 1.9
mini.energy_source.emissions = 1.2/150
mini.energy_usage = "180kW"
mini.ingredient_count = 3
mini.module_slots = 2
mini.fluid_boxes=nil
data:extend{mini}

mini = MiniCopy(data.raw["furnace"]["electric-furnace"],2/3)
mini.max_health = 140
mini.corpse = "medium-remnants"
mini.crafting_speed = 1
mini.energy_source.emissions = .8/180
mini.module_slots = 1
mini.fast_replaceable_group = "furnace"
data:extend{mini}
