data:extend(
{
  {
    type = "technology", name = "miniaturization-1",
    icon = "__Miniaturization__/graphics/icons/miniaturization.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "mini-assembling-machine-1"
      },
      {
        type = "unlock-recipe",
        recipe = "mini-assembling-machine-2"
      },
    },
    prerequisites = {"advanced-material-processing", "optics"},
    unit =
    {
      count = 60,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
      },
      time = 45
    },
    order = "d-m-a"
  },
  {
    type = "technology", name = "miniaturization-2",
    icon = "__Miniaturization__/graphics/icons/miniaturization.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "mini-assembling-machine-3"
      }
    },
    prerequisites = {"miniaturization-1","modules"},
    unit =
    {
      count = 60,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
      },
      time = 60
    },
    order = "d-m-b",
	upgrade = true
  },
  {
    type = "technology", name = "miniaturization-3",
    icon = "__Miniaturization__/graphics/icons/miniaturization.png",
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "mini-electric-furnace"
      },
    },
    prerequisites = {"miniaturization-2","advanced-material-processing-2"},
    unit =
    {
      count = 30,
      ingredients =
      {
        {"science-pack-1", 2},
        {"science-pack-2", 2},
        {"science-pack-3", 3},
        {"alien-science-pack", 1},
      },
      time = 90
    },
    order = "d-m-c",
	upgrade = true
  },
})

table.insert(data.raw["technology"]["armor-making-3"].prerequisites,"miniaturization-1")

table.insert(data.raw["technology"]["energy-shield-mk2-equipment"].prerequisites,"miniaturization-2")
table.insert(data.raw["technology"]["battery-mk2-equipment"].prerequisites,"miniaturization-2")
table.insert(data.raw["technology"]["power-armor-2"].prerequisites,"miniaturization-2")
